<?php

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
C::import('class/base', 'plugin/xinxiuvip_network', false);
C::import('class/client', 'plugin/xinxiuvip_network', false);

global $_G;

class function_login extends class_client
{
    public $action_all = array('external', 'login_md5', 'login_exit', 'login_counts', 'safe_set_password', 'login_get_sms', 'login_get_globals', 'login_md5', 'login_user', 'login_register', 'login_config', 'email_set_password', 'login_getsafe', 'login_setsafe');//所有接口必填，用逗号隔开！！！除以下key、adminkey所包含以外，未包含的接口都是通过token令牌进行访问。
    public $function_action_key = array('external', 'login_cards', 'login_counts', 'login_get_globals', 'login_user', 'login_config', 'login_register', 'login_md5', 'safe_set_password', 'email_set_password');//使用key密钥访问的接口
    public $function_action_adminkey = array('');//使用管理密钥adminkey访问的接口

    public function __construct()
    {
        parent::__construct();
    }

    /**
     * 获取内存cache值
     * @param // key为变量cache_key
     * @param // 如果为真返回所有内存值信息，如果为空返回变量值
     * @return bool//成功返回真、否则返回假
     */
    public function external($keys, $type = false)
    {    //获取外部内存变量
        if ($type) {
            $data = DB::fetch_first('select * from %t where cache_key=%s', array('xinxiuvip_network_cache_external', $keys));
            xx_output::json_output(200, '', $data);
        } else {
            $data = DB::result_first('select cache_value from %t where cache_key=%s', array('xinxiuvip_network_cache_external', $keys));
            $array = array('keys' => $keys, 'value' => $data);
            xx_output::json_output(200, '', $array);
        }
    }

    public function login_md5($rmd5)
    {//软件md5加密验证，传入软件md5签名,不区分大小写
        $ismd5 = xx_G::xinxiuvip_network('ismd5');
        if ($ismd5) {
            $rmd5s = explode(';', $ismd5);
            $data = array('md5' => trim($rmd5));
            !in_array($rmd5, $rmd5s) ? xx_output::json_output(400, 'error08') : xx_output::json_output(200, '', $data);
        } else {
            xx_output::json_output(400, 'error011');
        }
    }

    public function login_exit()
    {
        $uid = xx_client::uid_by_token();
        if (xx_G::xinxiuvip_network('tokens')) {
            $tokens = DB::result_first('SELECT tokens FROM %t WHERE uid=%d', array('xinxiuvip_network_token', $uid));
            $tokens = unserialize($tokens);//反序列化
            $get_token = xx_client::safe_check('token', false);
            if (in_array($get_token, $tokens)){
                $key = array_search($get_token, $tokens);
                unset($tokens[$key]);
            }
            $tokens = array_values($tokens);
            $tokens = serialize($tokens);
            DB::update('xinxiuvip_network_token', array('tokens' => $tokens), 'uid=' . $uid, true, true);
            xx_output::json_output(200, 'OK', array('uid' => $uid, 'token' => $_GET['token']));
        } else {
            DB::update('xinxiuvip_network_token', array('token' => 'login_exit'), 'uid=' . $uid, true, true);
            xx_output::json_output(200, 'OK', array('uid' => $uid, 'token' => $_GET['token']));
        }
    }

    public function login_counts($times = '')//统计在线人数
    {
        $data = array();
        if (empty($times)) {
            $min = DB::result_first('SELECT count(*) FROM %t WHERE (lastactivity BETWEEN %d and %d) ', array('xinxiuvip_network_token', time() - 60, time()));
            $data['min'] = $min;
            $hour = DB::result_first('SELECT count(*) FROM %t WHERE (lastactivity BETWEEN %d and %d) ', array('xinxiuvip_network_token', time() - 3600, time()));
            $data['hour'] = $hour;
            $day = DB::result_first('SELECT count(*) FROM %t WHERE (lastactivity BETWEEN %d and %d) ', array('xinxiuvip_network_token', time() - 86400, time()));
            $data['day'] = $day;
        } else {
            $kstime = time() - $times;
            $jstime = time();
            $str = DB::result_first('SELECT count(*) FROM %t WHERE (lastactivity BETWEEN %d and %d) ', array('xinxiuvip_network_token', $kstime, $jstime));
            $data['times'] = $str;
        }
        xx_output::json_output(200, '', $data);
    }

    public function safe_set_password($username, $safe, $password)
    {//利用安全码修改密码

        $user_arr = xx_dz_members::get_by_uid($username);

        $get_username = $user_arr['username'];

        $get_uid = $user_arr['uid'];

        $safe_old = DB::result_first('SELECT safe FROM %t WHERE uid=%d', array('xinxiuvip_network_members', $get_uid));//获取原始安全码

        empty($safe_old) ? xx_output::json_output(400, 'error0025') : true; //判断原安全码是否为空

        if (strtolower($safe_old) == strtolower($safe)) {
            $edit_id = uc_user_edit($get_username, '', $password, '', 1);
            if ($edit_id >= 0) {
                xx_output::json_output(200, '', array('uid' => $get_uid, 'username' => $get_username, 'password' => $password));
            } else {
                xx_output::json_output(400, 'error_id:' . $edit_id);
            }
        } else {
            xx_output::json_output(400, 'error0028');
        }
    }


    public function email_set_password($email, $code)
    {//邮箱找回密码
        global $_G;
        require_once libfile('function/mail');
        $user = DB::fetch_first('SELECT * FROM %t WHERE email=%s', array('xinxiuvip_network_members', $email));
        if (empty($user)) {
            xx_output::json_output('400', 'error00120');
        }

        if (empty($code)) {
            $code = rand(1000, 9999);
            $subject = '找回密码';
            $message = xx_G::xinxiuvip_network('mmemail');
            $message = xx_convert::str_replace_array($message, array(
                '[uid]' => $user['uid'],
                '[username]' => $user['username'],
                '[time]' => time(),
                '[ip]' => $_G['clientip'],
                '[code]' => $code,
                '[email]' => $user['email']
            ));//按加密规则进行数据替换
            $str = sendmail($email, $subject, $message, $_G['setting']['adminemail']);
            if ($str) {
                global $_G;
                $dateline = time();
                $oldtime = time() + 120;
                $sql = array(
                    'type' => 0,
                    'email' => $email,
                    'code' => $code,
                    'content' => $subject,
                    'template' => $message,
                    'dateline' => $dateline,
                    'oldtime' => $oldtime,
                    'ip' => $_G['clientip'],
                );
                DB::insert('xinxiuvip_network_email_log', $sql, true, true);
                $data = array(
                    'toemail' => $email,
                    'uid' => $user['uid'],
                    'username' => $user['username'],
                );
                xx_output::json_output('200', '', $data);
            } else {
                xx_output::json_output('400', 'error0071');
            }
        } else {
            $oldcode = DB::result_first('SELECT code FROM %t WHERE email=%s', array('xinxiuvip_network_email_log', $email));//获取原始安全码
            $oldcode == $code ? true : xx_output::json_output(400, 'error00119');
            $password = xx_client::safe_check('password', true);
            $edit_id = uc_user_edit($user['username'], '', $password, '', 1);
            if ($edit_id >= 0) {
                DB::update('xinxiuvip_network_email_log', array('code' => ''), array('email' => $email), true, true);
                xx_output::json_output(200, '', array('uid' => $user['uid'], 'username' => $user['username'], 'password' => $password));
            } else {
                xx_output::json_output(400, 'error_id:' . $edit_id);
            }
        }

    }

    public function login_get_globals($id, $int)
    {//读取全局变量
        $text = 'text' . $int;
        $str = DB::result_first('select ' . $text . ' from %t where id=%d', array('xinxiuvip_network_globals', $id), true);
        is_null($str) ? xx_output::json_output(400, 'error0128') : true;
        $data = array(
            'id' => $id,
            'globals' . $int => $str,
        );
        xx_output::json_output(200, 'OK', $data);
    }


    public function login_user($username, $password, $questionid, $answer)
    {

        $username = xx_dz_members::get_by_uid($username, 'uid');

        empty($username) ? xx_output::json_output(400, 'error0011') : true;

        $secques = DB::fetch_first('SELECT secques FROM %t WHERE uid=%d', array('ucenter_members', $username));

        $secques ? $checkques = 1 : $checkques = 0;

        //登录用户前传输hook
        xx_client::class_hook('hook_login_user_start');
        //登录用户前传输hook

        /**
         * 用户登录
         *
         * @param string $username 用户名
         * @param string $password 密码
         * @param int $isuid 是否使用UID登录
         * @param int $checkques 是否检查安全问题
         * @param string $questionid 安全问题ID
         * @param string $answer 安全问题答案
         * @param string $ip 登录IP
         * @param int $nolog 是否不记录登录
         * @return mixed 登录结果
         */
        $data = uc_user_login($username, $password, 1, $checkques, $questionid, $answer);
        $uid = $data['0'];

        //登录用户后传输hook
        xx_client::class_hook('hook_login_user_end', array($data));
        //登录用户后传输hook


        if ($uid > 0) {
            ////=======新增用户表操作
            $str = DB::fetch_first('SELECT * FROM %t WHERE uid=%d', array('xinxiuvip_network_members', $uid));

            empty($str) ? xx_client::register_member($uid) : true;

            xx_client::login_groupids($uid);//判断是否是计时模式过期判断卡号是否封号

            ////=======新增用户表操作
            $result = xx_client::login_get_uid($uid);//通过uid获取登录返回信息

            xx_output::json_output(200,'',$result);
            //xx_output::json_output(200, '', $result);
        } elseif ($uid == -1) {
            xx_output::json_output(400, 'error0011');
        } elseif ($uid == -2) {
            xx_output::json_output(400, 'error0012');
        } elseif ($uid == -3) {
            xx_output::json_output(400, 'error00118');
        } else {
            xx_output::json_output(400, 'error0013');
        }
    }


    public function login_register($username, $password, $email, $questionid = '', $answer = '', $invitecode = '', $safe = '')
    {//用户注册，通过uc注册
        global $_G;

        $invitecode ? $invite = xx_dz_members::get_invite_code($invitecode) : true;//判断邀请码是否可以使用

        if ($_G['setting']['regstatus'] >= 2) {//判断后台是否开启邀请码注册
            $invite ? true : xx_output::json_output(400, 'error00121');
        }

        //注册用户前传输hook
        xx_client::class_hook('hook_login_register_start');
        //注册用户前传输hook
        $uid = uc_user_register($username, $password, $email, $questionid, $answer, $_G['clientip']);
        //注册用户后传输hook
        xx_client::class_hook('hook_login_register_end', array($uid));
        //注册用户后传输hook
        if ($uid <= 0) {
            if ($uid == -1) {
                xx_output::json_output(400, 'error0015');
            } elseif ($uid == -2) {
                xx_output::json_output(400, 'error0016');
            } elseif ($uid == -3) {
                xx_output::json_output(400, 'error0017');
            } elseif ($uid == -4) {
                xx_output::json_output(400, 'error0018');
            } elseif ($uid == -5) {
                xx_output::json_output(400, 'error0019');
            } elseif ($uid == -6) {
                xx_output::json_output(400, 'error00110');
            } else {
                xx_output::json_output(400, 'error00111');
            }
        } else {
            if ($invite) {
                xx_dz_members::set_invite_code($uid, $invitecode, $username);//如果邀请码状态为可用，则使用邀请码
            }
            ///=============自动激活代码===开始
            xx_dz_members::login_dz_register($uid, $username, $password, $email);
            ///=============自动激活代码===结束
            ////=======新增用户表操作
            xx_client::register_member($uid);//初始化插件的自定义表
            xx_client::login_groupids($uid);//判断帐号
            ////=======新增用户表操作

            if ($safe) {// 添加安全码，并加密保存
                $salt = DB::result_first('select salt from %t where uid=%d', array('ucenter_members', $uid));
                $safe = md5(md5($safe) . $salt);
                DB::update('xinxiuvip_network_members', array('safe' => $safe), 'uid=' . $uid, true);
            }

            $result = xx_client::login_get_uid($uid);//通过uid获取登录返回信息
            xx_output::json_output(200, '', $result);
        }

    }

    public function login_config()
    {//获取软件配置信息
        $data = $this->config;
        $result = array(
            'version' => $data['versions'],
            'Notice' => $data['Notices'],
            'updateurl' => $data['updateurl']
        );
        xx_output::json_output(200, '', $result);
    }

    public function login_cards($sgin)
    {//卡号登录

        $xinxiu_data = DB::fetch_first('SELECT * FROM %t WHERE sgin=%s', array('xinxiuvip_network_members', $sgin));
        if (empty($xinxiu_data)) {   /// 如果查询用户数据库表，没有该账号，就搜索卡号数据库
            $data = DB::fetch_first('SELECT * FROM %t WHERE sgin=%s', array('xinxiuvip_network_kahao', $sgin));
            if (empty($data)) {
                xx_output::json_output(400, 'error00115');
            } elseif ($data['status'] == 1) {
                xx_output::json_output(400, 'error00114');
            } elseif ($data['types'] == 1) {
                xx_output::json_output(400, 'error00116');
            }

            $username = time();
            $password = substr(md5($sgin), -8, 8); // 后八位
            $email = $username . '@qq.com';
            $ucemail = uc_user_checkemail($email);//判断邮箱是否被激活
            if ($ucemail < 0) {
                $email = $username . rand(0, 9) . '@qq.com';
            }
            $ucname = uc_user_checkname($username);//判断用户名是否被使用
            if ($ucname < 0) {
                $username = $username . rand(0, 9);
            }
            $uid = uc_user_register($username, $password, $email);

            if ($uid <= 0) {
                if ($uid == -1) {
                    xx_output::json_output(400, 'error0015');
                } elseif ($uid == -2) {
                    xx_output::json_output(400, 'error0016');
                } elseif ($uid == -3) {
                    xx_output::json_output(400, 'error0017');
                } elseif ($uid == -4) {
                    xx_output::json_output(400, 'error0018');
                } elseif ($uid == -5) {
                    xx_output::json_output(400, 'error0019');
                } elseif ($uid == -6) {
                    xx_output::json_output(400, 'error00110');
                } else {
                    xx_output::json_output(400, 'error00111');
                }
            } else {
                ///=============自动激活代码===开始
                xx_dz_members::login_dz_register($uid, $username, $password, $email);
                ///=============自动激活代码===结束

                ////=======新增用户表操作
                ///////----激活私人变量表
                $id = DB::result_first('select id from %t where uid=%d', array('xinxiuvip_network_fields', $uid));
                if (empty($id)) {
                    DB::insert('xinxiuvip_network_fields', array('uid' => $uid), true, true, true);//初始化插件的自定义表
                }
                ///////----激活私人变量表
                ////=======新增用户表操作

                ////=======新注册卡号赠送处理
                $regtime = $this->config['regtime'];
                $times = time() + $regtime + $data['sgintime'];
                updatemembercount($uid, array($this->config['credits'] => intval($data['credits'])), true);
                updatemembercount($uid, array($this->config['jiaoyi'] => intval($data['buycredits'])), true);
                DB::update('xinxiuvip_network_kahao', array('uid' => $uid, 'clearline' => time(), 'types' => 1, 'sgintime' => 0, 'credits' => 0, 'buycredits' => 0, 'tokens' => 0), array('sgin' => $sgin), true);

                DB::insert('xinxiuvip_network_members', array('uid' => $uid, 'sgin' => $data['sgin'], 'username' => $username, 'email' => $email, 'inttoken' => $data['tokens'], 'dateline' => $times, 'clearline' => time()), true, true, true);//新增加帐号数据库表
                //////=======新增用户表操作
                //$this->register_cards($uid);//初始化插件的自定义表
                xx_client::login_groupids($uid);//判断帐号
                ////=======新增用户表操作
                $result = xx_client::login_get_uid($uid);
                $result['password'] = $password;
                xx_output::json_output(200, '', $result);
            }
        } else {
            $uid = $xinxiu_data['uid'];
            xx_client::login_groupids($uid);
            ////=======新增用户表操作
            $result = xx_client::login_get_uid($uid);
            xx_output::json_output(200, '', $result);

        }
    }
}


